我正在编写一个脚本来下载一堆文件,我希望它能在特定文件不存在时通知。
r=`wget -q www.someurl.com`
if [ $r -ne 0 ]
then echo "Not there"
else echo "OK"
fi
但它在执行时出现以下错误:
./file: line 2: [: -ne: unary operator expected
怎么了?
答案 0 :(得分:61)
其他人已正确发布您可以使用$?
获取最新的退出代码:
wget_output=$(wget -q "$URL")
if [ $? -ne 0 ]; then
...
这使您可以捕获stdout和退出代码。如果您实际上并不关心它打印的内容,您可以直接测试它:
if wget -q "$URL"; then
...
如果你想抑制输出:
if wget -q "$URL" > /dev/null; then
...
答案 1 :(得分:38)
$r
是wget的文本输出(您使用反引号捕获)。要访问返回代码,请使用$?
变量。
答案 2 :(得分:12)
$r
为空,因此您的条件变为if [ -ne 0 ]
,似乎-ne
被用作一元运算符。试试这个:
wget -q www.someurl.com
if [ $? -ne 0 ]
...
编辑正如Andrew在我之前解释的那样,反引号会返回标准输出,而$?
会返回上一次操作的退出代码。
答案 3 :(得分:10)
你可以
wget ruffingthewitness.com && echo "WE GOT IT" || echo "Failure"
-(~)----------------------------------------------------------(07:30 Tue Apr 27)
risk@DockMaster [2024] --> wget ruffingthewitness.com && echo "WE GOT IT" || echo "Failure"
--2010-04-27 07:30:56-- http://ruffingthewitness.com/
Resolving ruffingthewitness.com... 69.56.251.239
Connecting to ruffingthewitness.com|69.56.251.239|:80... connected.
HTTP request sent, awaiting response... 200 OK
Length: unspecified [text/html]
Saving to: `index.html.1'
[ <=> ] 14,252 72.7K/s in 0.2s
2010-04-27 07:30:58 (72.7 KB/s) - `index.html.1' saved [14252]
WE GOT IT
-(~)-----------------------------------------------------------------------------------------------------------(07:30 Tue Apr 27)
risk@DockMaster [2025] --> wget ruffingthewitness.biz && echo "WE GOT IT" || echo "Failure"
--2010-04-27 07:31:05-- http://ruffingthewitness.biz/
Resolving ruffingthewitness.biz... failed: Name or service not known.
wget: unable to resolve host address `ruffingthewitness.biz'
zsh: exit 1 wget ruffingthewitness.biz
Failure
-(~)-----------------------------------------------------------------------------------------------------------(07:31 Tue Apr 27)
risk@DockMaster [2026] -->
答案 4 :(得分:1)
我一直在努力尝试所有的解决方案。
wget以非交互方式执行。这意味着wget在后台工作,你无法用$ ?.
来捕获de return代码一个解决方案是处理“--server-response”属性,搜索http 200状态代码 例如:
wget --server-response -q -o wgetOut http://www.someurl.com
sleep 5
_wgetHttpCode=`cat wgetOut | gawk '/HTTP/{ print $2 }'`
if [ "$_wgetHttpCode" != "200" ]; then
echo "[Error] `cat wgetOut`"
fi
注意:wget需要一些时间来完成他的工作,因此我把“睡5”。这不是最好的方法,但可以测试解决方案。
答案 5 :(得分:0)
从wget捕获结果并检查呼叫状态的最佳方法
wget -O filename URL
if [[ $? -ne 0 ]]; then
echo "wget failed"
exit 1;
fi
通过这种方式,您可以检查wget的状态以及存储输出数据。
如果呼叫成功,请使用存储的输出
否则将退出并显示错误wget failed